---------------------------------------------------------------------------------------------
--ATF version: 2.2
--Created date: 12/Nov/2015
--Author: Ta Thanh Dong
---------------------------------------------------------------------------------------------
Test = require('connecttest')
require('cardinalities')
local events = require('events')
local mobile_session = require('mobile_session')

---------------------------------------------------------------------------------------------
-----------------------------Required Shared Libraries---------------------------------------
---------------------------------------------------------------------------------------------
local commonFunctions = require('user_modules/shared_testcases/commonFunctions')
local commonSteps = require('user_modules/shared_testcases/commonSteps')
local commonTestCases = require('user_modules/shared_testcases/commonTestCases')
local integerParameterInNotification = require('user_modules/shared_testcases/testCasesForIntegerParameterInNotification')
local floatParameterInNotification = require('user_modules/shared_testcases/testCasesForFloatParameterInNotification')
local stringParameterInNotification = require('user_modules/shared_testcases/testCasesForStringParameterInNotification')
local enumParameterInNotification = require('user_modules/shared_testcases/testCasesForEnumerationParameterInNotification')
local booleanParameterInNotification = require('user_modules/shared_testcases/testCasesForBooleanParameterInNotification')
local doubleParameterInNotification = require('user_modules/shared_testcases/testCasesForDoubleParameterInNotification')
local testCasesForPolicyTable = require('user_modules/shared_testcases/testCasesForPolicyTable')
local SDLConfig = require('user_modules/shared_testcases/SmartDeviceLinkConfigurations')
local functionId = require('function_id')
require('user_modules/AppTypes')

APIName = "OnVehicleData" -- set API name
config.deviceMAC = "12ca17b49af2289436f303e0166030a21e525d266e209267433801a8fd4071a0"
Apps = {}
Apps[1] = {}
Apps[1].storagePath = config.pathToSDL .. SDLConfig:GetValue("AppStorageFolder") .. "/"..config.application1.registerAppInterfaceParams.appID.. "_" .. config.deviceMAC.. "/"
Apps[1].appName = config.application1.registerAppInterfaceParams.appName
local abs_state_values = {"INACTIVE", "ACTIVE"}
local tpms_values = {"UNKNOWN", "SYSTEM_FAULT", "SENSOR_FAULT", "LOW", "SYSTEM_ACTIVE", "TRAIN_LF_TIRE", "TRAIN_RF_TIRE", "TRAIN_RR_TIRE", "TRAIN_ORR_TIRE", "TRAIN_IRR_TIRE", "TRAIN_LR_TIRE", "TRAIN_OLR_TIRE", "TRAIN_ILR_TIRE", "TRAINING_COMPLETE", "TIRES_NOT_TRAINED"}
local turn_signal_values = {"OFF", "LEFT", "RIGHT", "UNUSED"}
local tire_pressure_value_params = {"leftFront", "rightFront", "leftRear", "rightRear", "innerLeftRear", "innerRightRear"
--, "frontRecommended", "rearRecommended"
}
local permission_lines_subscribe_vehicle_data =
[[ "SubscribeVehicleData": {
  "hmi_levels": [
  "BACKGROUND",
  "FULL",
  "LIMITED"
  ],
  "parameters": [
  "gps",
  "speed",
  "rpm",
  "fuelLevel",
  "fuelLevel_State",
  "instantFuelConsumption",
  "externalTemperature",
  "prndl",
  "tirePressure",
  "odometer",
  "beltStatus",
  "bodyInformation",
  "deviceStatus",
  "driverBraking",
  "wiperStatus",
  "headLampStatus",
  "engineTorque",
  "accPedalPosition",
  "steeringWheelAngle",
  "eCallInfo",
  "airbagStatus",
  "emergencyEvent",
  "clusterModeStatus",
  "myKey",
  "fuelRange",
  "abs_State",
  "tirePressureValue",
  "tpms",
  "turnSignal"
  ]
}]]

local permission_lines_on_vehicle_data =
[[ "OnVehicleData": {
  "hmi_levels": [
  "BACKGROUND",
  "FULL",
  "LIMITED"
  ],
  "parameters": [
  "gps",
  "speed",
  "rpm",
  "fuelLevel",
  "fuelLevel_State",
  "instantFuelConsumption",
  "externalTemperature",
  "prndl",
  "tirePressure",
  "odometer",
  "beltStatus",
  "bodyInformation",
  "deviceStatus",
  "driverBraking",
  "wiperStatus",
  "headLampStatus",
  "engineTorque",
  "accPedalPosition",
  "steeringWheelAngle",
  "eCallInfo",
  "airbagStatus",
  "emergencyEvent",
  "clusterModeStatus",
  "myKey",
  "fuelRange",
  "abs_State",
  "tirePressureValue",
  "tpms",
  "turnSignal"
  ]
}]]
---------------------------------------------------------------------------------------------
------------------------------------------Common functions-----------------------------------
---------------------------------------------------------------------------------------------

local svd_values = { gps = "VEHICLEDATA_GPS",
  speed = "VEHICLEDATA_SPEED",
  rpm = "VEHICLEDATA_RPM",
  fuelLevel = "VEHICLEDATA_FUELLEVEL",
  fuelLevel_State = "VEHICLEDATA_FUELLEVEL_STATE",
  instantFuelConsumption = "VEHICLEDATA_FUELCONSUMPTION",
  externalTemperature = "VEHICLEDATA_EXTERNTEMP",
  prndl = "VEHICLEDATA_PRNDL",
  tirePressure = "VEHICLEDATA_TIREPRESSURE",
  odometer = "VEHICLEDATA_ODOMETER",
  beltStatus = "VEHICLEDATA_BELTSTATUS",
  bodyInformation = "VEHICLEDATA_BODYINFO",
  deviceStatus = "VEHICLEDATA_DEVICESTATUS",
  driverBraking = "VEHICLEDATA_BRAKING",
  wiperStatus = "VEHICLEDATA_WIPERSTATUS",
  headLampStatus = "VEHICLEDATA_HEADLAMPSTATUS",
  engineTorque = "VEHICLEDATA_ENGINETORQUE",
  accPedalPosition = "VEHICLEDATA_ACCPEDAL",
  steeringWheelAngle = "VEHICLEDATA_STEERINGWHEEL",
  eCallInfo = "VEHICLEDATA_ECALLINFO",
  airbagStatus = "VEHICLEDATA_AIRBAGSTATUS",
  emergencyEvent = "VEHICLEDATA_EMERGENCYEVENT",
  clusterModeStatus = "VEHICLEDATA_CLUSTERMODESTATUS",
  myKey = "VEHICLEDATA_MYKEY",
  fuelRange = "VEHICLEDATA_FUELRANGE",
  abs_State = "VEHICLEDATA_ABS_STATE",
  tirePressureValue = "VEHICLEDATA_TIREPRESSURE_VALUE",
  tpms = "VEHICLEDATA_TPMS",
turnSignal = "VEHICLEDATA_TURNSIGNAL"}

local all_vehicle_data = { "gps",
  "speed",
  "rpm",
  "fuelLevel",
  "fuelLevel_State",
  "instantFuelConsumption",
  "externalTemperature",
  "prndl",
  "tirePressure",
  "odometer",
  "beltStatus",
  "bodyInformation",
  "deviceStatus",
  "driverBraking",
  "wiperStatus",
  "headLampStatus",
  "engineTorque",
  "accPedalPosition",
  "steeringWheelAngle",
  "eCallInfo",
  "airbagStatus",
  "emergencyEvent",
  "clusterModeStatus",
  "myKey",
  "fuelRange",
  "abs_State",
  "tirePressureValue",
  "tpms",
"turnSignal"}

function Test:subscribeVehicleDataSuccess(params_send)
  local function SetSvdRequest(params_send)
    local temp = {}
    for i = 1, #params_send do
      temp[params_send[i]] = true
    end
    return temp
  end
  
  local function SetSvdResponse(params_send, vehicle_data_result_code)
    local temp = {}
    local vehicle_data_result_code_value = ""
    
    if vehicle_data_result_code ~= nil then
      vehicle_data_result_code_value = vehicle_data_result_code
    else
      vehicle_data_result_code_value = "SUCCESS"
    end
    
    for i = 1, #params_send do
      if params_send[i] == "clusterModeStatus" then
        temp["clusterModes"] = {
          resultCode = vehicle_data_result_code_value,
          dataType = svd_values[params_send[i]]
        }
      else
        temp[params_send[i]] = {
          resultCode = vehicle_data_result_code_value,
          dataType = svd_values[params_send[i]]
        }
      end
    end
    return temp
  end
  
  local function CreateSuccessExpectedResult(response)
    response["success"] = true
    response["resultCode"] = "SUCCESS"
    
    return response
  end
  
  local request = SetSvdRequest(params_send)
  local response = SetSvdResponse(params_send)
  
  --mobile side: sending SubscribeVehicleData request
  local cid = self.mobileSession:SendRPC("SubscribeVehicleData",request)
  
  --hmi side: expect SubscribeVehicleData request
  EXPECT_HMICALL("VehicleInfo.SubscribeVehicleData",request)
  :Do(function(_,data)
    --hmi side: sending VehicleInfo.SubscribeVehicleData response
    self.hmiConnection:SendResponse(data.id, data.method, "SUCCESS", response)
  end)
  
  local expected_result = CreateSuccessExpectedResult(response)
  
  --mobile side: expect SubscribeVehicleData response
  EXPECT_RESPONSE(cid, expected_result)
  
  --mobile side: expect OnHashChange notification
  EXPECT_NOTIFICATION("OnHashChange")
end

---------------------------------------------------------------------------------------------
-------------------------- Overwrite These Functions For This Script-------------------------
---------------------------------------------------------------------------------------------
--Specific functions for this script
--1. verify_SUCCESS_Notification_Case(notification,expect_notification)
--2. verify_Notification_IsIgnored_Case(notification)
---------------------------------------------------------------------------------------------

--This function is used to send default request and response with specific valid data and verify SUCCESS resultCode
-- Note: vin in Notification from HMI will be ignored by SDL according to APPLINK-26880
function Test:verify_SUCCESS_Notification_Case(notification, expect_notification)
  local exp_notification
  if expect_notification == nil then
    exp_notification = notification
  else
    exp_notification = expect_notification
  end
  
  self.hmiConnection:SendNotification("VehicleInfo.OnVehicleData", notification)
  --mobile side: expected SubscribeVehicleData response
  EXPECT_NOTIFICATION("OnVehicleData", exp_notification)
end

function Test:verify_Notification_IsIgnored_Case(notification)
  commonTestCases:DelayedExp(1000)
  self.hmiConnection:SendNotification("VehicleInfo.OnVehicleData", notification)
  --mobile side: expected Notification
  EXPECT_NOTIFICATION("OnVehicleData", notification)
  :Times(0)
end

---------------------------------------------------------------------------------------------
-------------------------------------------Preconditions-------------------------------------
---------------------------------------------------------------------------------------------

--Print new line to separate Preconditions
commonFunctions:newTestCasesGroup("Preconditions")

--Delete app_info.dat, logs and policy table
commonSteps:DeleteLogsFileAndPolicyTable()

--1. Activate application
commonSteps:ActivationApp()

--2. Update policy to allow request
testCasesForPolicyTable:Precondition_updatePolicy_By_overwriting_preloaded_pt("files/PTU_ForVehicleData.json")

----Get appID Value on HMI side
function Test:GetAppID()
  Apps[1].appID = self.applications[Apps[1].appName]
end

function Test:SubscribeVehicleData_Positive()
  self:subscribeVehicleDataSuccess(all_vehicle_data)
end

------------------------------------------------Test-----------------------------------------
---------------------------------------------------------------------------------------------
--11.prndl: type=Common.PRNDL mandatory=false
--Enumerations:
local PRNDL = {"PARK", "REVERSE", "NEUTRAL", "DRIVE", "SPORT", "LOWGEAR", "FIRST", "SECOND", "THIRD", "FOURTH", "FIFTH", "SIXTH", "SEVENTH", "EIGHTH", "FAULT"}
local notification = {rpm = 1}
enumParameterInNotification:verify_Enumeration_Parameter(notification, {"prndl"}, PRNDL, false)

-------------------------------------------Postcondition-------------------------------------
---------------------------------------------------------------------------------------------
  
  --Print new line to separate Postconditions
  commonFunctions:newTestCasesGroup("Postconditions")
  testCasesForPolicyTable:Restore_preloaded_pt()
  Test["Stop_SDL"] = function(self)
    StopSDL()
  end